OpenTTD

- Main Page
- Related Pages
- Modules
- Namespaces
- Data Structures
- Files

- Data Structures
- Class Hierarchy
- Data Fields

Public Member Functions | Data Fields
FileStringReader Struct Reference

A reader that simply reads using fopen. More...

Inheritance diagram for FileStringReader:

## Public Member Functions
| FileStringReader (StringData &data, const char *file, bool master, bool translation)
| Create the reader.
virtual | ~FileStringReader ()
| Free/close the file.
char * | ReadLine (char *buffer, const char *last)
| Read a single line from the source of strings.
void | HandlePragma (char *str)
| Handle the pragma of the file.
void | ParseFile ()
| Start parsing the file.
Public Member Functions inherited from StringReader
| StringReader (StringData &data, const char *file, bool master, bool translation)
| Prepare reading.
virtual | ~StringReader ()
| Make sure the right reader gets freed.
void | HandleString (char *str)

## Data Fields
FILE * | fh
| The file we are reading.
Data Fields inherited from StringReader
StringData & | data
| The data to fill during reading.
const char * | file
| The file we are reading.
bool | master
| Are we reading the master file?
bool | translation
| Are we reading a translation, implies !master. However, the base translation will have this false.

## Detailed Description

A reader that simply reads using fopen.

Definition at line 102 of file strgen.cpp.

## Constructor & Destructor Documentation

FileStringReader::FileStringReader | ( | StringData & | data,
|  | const char * | file,
|  | bool | master,
|  | bool | translation
| ) |  |
| inline

Create the reader.

Parameters

  data | The data to fill during reading.
  file | The file we are reading.
  master | Are we reading the master file?
  translation | Are we reading a translation?

Definition at line 112 of file strgen.cpp.

References error(), and fh.

virtual FileStringReader::~FileStringReader | ( |  | ) |
| inline virtual

Free/close the file.

Definition at line 120 of file strgen.cpp.

References fh.

## Member Function Documentation

void FileStringReader::HandlePragma | ( | char * | str | ) |
| virtual

Handle the pragma of the file.

Parameters

  str | The pragma string to parse.

Reimplemented from StringReader.

Definition at line 142 of file strgen.cpp.

References _lang, LanguagePackHeader::cases, StringReader::data, LanguagePackHeader::digit_decimal_separator, LanguagePackHeader::digit_group_separator, LanguagePackHeader::digit_group_separator_currency, error(), LanguagePackHeader::genders, LanguagePackHeader::isocode, lastof, StringReader::master, MAX_NUM_CASES, MAX_NUM_GENDERS, LanguagePackHeader::name, NBSP, LanguagePackHeader::newgrflangid, StringData::next_string_id, LanguagePackHeader::num_cases, LanguagePackHeader::num_genders, LanguagePackHeader::own_name, strecpy(), TD_LTR, TD_RTL, LanguagePackHeader::text_dir, and LanguagePackHeader::winlangid.

char* FileStringReader::ReadLine | ( | char * | buffer,
|  | const char * | last
| ) |  |
| inline virtual

Read a single line from the source of strings.

Parameters

  buffer | The buffer to read the data in to.
  last | The last element in the buffer.

Returns
  The buffer, or NULL if at the end of the file.

Implements StringReader.

Definition at line 125 of file strgen.cpp.

References ClampToU16(), and fh.

The documentation for this struct was generated from the following file:

- src/strgen/strgen.cpp